#!/system/bin/sh

MODDIR=${0%/*}

create_sys_perm() {
  mkdir -p $1
  chmod 700 $1
  chcon u:object_r:system_file:s0 $1
}

if [ "$ZYGISK_ENABLED" ]; then
  sed 's/description=/description=\['$(echo -e '\xE2\x9D\x8C')' Please disable Magisk'"'"'s zygisk and reboot!\]/g' \
    $MODDIR/module.prop > $MODDIR/module.prop
  exit 0
fi

cd "$MODDIR"

if [ "$(which magisk)" ]; then
  for file in ../*; do
    if [ -d "$file" ] && [ -d "$file/zygisk" ] && ! [ -f "$file/disable" ]; then
      if [ -f "$file/post-fs-data.sh" ]; then
        cd "$file"
        log -p i -t "zygisk-sh" "Manually trigger post-fs-data.sh for $file"
        sh "$(realpath ./post-fs-data.sh)"
        cd "$MODDIR"
      fi
    fi
  done
fi

mkdir -p /data/adb/zygisksu
[ -f /data/adb/zygisksu/znctx ] && mv /data/adb/zygisksu/znctx /data/adb/zygisksu/znctx.old
[ -f /data/adb/zygisksu/modules_info ] && mv /data/adb/zygisksu/modules_info /data/adb/zygisksu/modules_info.old

if [ -d /data/adb/ksu/log ]; then
  [ -f /data/adb/ksu/log/znctx ] && mv /data/adb/ksu/log/znctx /data/adb/ksu/log/znctx.old
  [ -f /data/adb/ksu/log/modules_info ] && mv /data/adb/ksu/log/modules_info /data/adb/ksu/log/modules_info.old
fi

[ "$DEBUG" = true ] && export RUST_BACKTRACE=1
[ -f /data/adb/zygisksu/klog ] && [ "1" == $(cat /data/adb/zygisksu/klog) ] && export KLOG_ENABLED=1
./bin/zygiskd64 daemon

if [ -d /data/adb/ksu/log ]; then
  cp /data/adb/zygisksu/znctx /data/adb/ksu/log/znctx
  cp /data/adb/zygisksu/modules_info /data/adb/ksu/log/modules_info
fi
